// C Source File
// Created 14/04/2003; 20:58:44

#include "mkcomplib.h"

/*===============================================================================================
== Creation of the caracter stats
=================================================================================================
== stat : table of stat to fill
== data : pointer of data to study
== length : length of data to study
=================================================================================================
== return the number of different caracters
===============================================================================================*/
unsigned short mk_stat(unsigned short stat[], unsigned char * data, unsigned short length) {

  unsigned short nL=0;
  
  memset(stat,0,256*sizeof(short));

  while (length--!=0)
    if ((stat[*(data++)]++)==0)
      nL++;  //count the different caracters

  return nL;
}


/*===============================================================================================
== Get the bit length of compress datas
=================================================================================================
== nodes : the node structur of the tree
== root : the root position
== stat : table of the caracter stats
=================================================================================================
== return the bit-length of the compressed datas
===============================================================================================*/
unsigned long eval_len(TREE tree[], unsigned char nL, unsigned short stat[256]) {
  unsigned long length=0;
  short j=0;
  short i;
  unsigned char l;

  for (j=0;j<nL-1;j++) {
    if ((tree[j].node_right&tree[j].node_left)==0 ) {
      i=j;
      l=1;
      while ((i=tree[i].father)!=0)
        l++;  //calculate it's length
      if (tree[j].node_right==0)
        length+=l*stat[tree[j].right_branch];
      if (tree[j].node_left==0)
        length+=l*stat[tree[j].left_branch];
//disp2("\nl=%d length=%ld",l,length)
    }
  }
  
  return length;
}


/*===============================================================================================
== Write the compressed data
=================================================================================================
== data : pointer of the data to compress
== length : length of data to compress
== nodes : NODE structure of the huffmann tree
== root : position of the root
== dest_end : address of the end of writing place
== offset : bit offset of writing
=================================================================================================
== return  if 0 there is a error (it can only be a memory error)
           else 1
===============================================================================================*/
char write_comp(unsigned char * data, unsigned short length, TREE tree[], unsigned char * dest_end, short offset) {
  struct CODE {
    unsigned char * ptr;
    unsigned char length;
    unsigned char offset;
  } * code;  //to remember the position of huffmann that has been already created

  short j;
  short i;
  unsigned char * pos=data+length;  //begin by the last caracter
  short l;
  unsigned char * ptr;
  short offset2;
  
  code=malloc(256*sizeof(struct CODE));
  if (code==NULL)
    return 0;

  memset(code,0,256*sizeof(struct CODE));
  *dest_end=0;

  if (offset==0)
    offset=7;
  else
    offset--;
  
//printf("ptr=%ld",dest_end);
  while (data!=pos--) {  //while we are not arrived at the beginning
//printf("  dest=%d  ",*dest_end);
    if (code[*pos].length==0) {  //the code has not been created
//printf("\nmk %c : ",*pos);
      code[*pos].ptr=dest_end;  //store the position
      code[*pos].offset=offset;
      l=1;  //calculate the bit-length
      //search the caract in the tree
      i=0;
      while (tree[i].node_left!=0 || tree[i].left_branch!=*pos) {
        if (tree[i].node_right==0 && tree[i].right_branch==*pos) {
          *dest_end|=(1<<offset);  //in the right branch 1 (else 0)
//printf("1");
          break;
        }
        i++;
      }
//if (!(tree[i].node_right==0 && tree[i].right_branch==*pos))
//  printf("0");
      if ((offset--)==0) {
        offset=7;
        *(--dest_end)=0;  //clean the space
      }
      while (tree[i].father!=0) { //climb the tree
        l++;
        *dest_end|=((tree[i].node)<<offset);  //in the right branch 1 (else 0)
//printf("%d",tree[i].node);
        if ((offset--)==0) {
          offset=7;
          *(--dest_end)=0;  //clean the space
        }
        i=tree[i].father;
      }
      code[*pos].length=l;
//printf(" = %d",l);
    } else {  //the caracter is alread coded
      ptr=code[*pos].ptr;
      offset2=code[*pos].offset;
//printf("| %c : ",*pos);
      for (j=code[*pos].length;j>0;j--) {  //copy of the code
        if ((*ptr)&(1<<offset2)) {
//printf("1");
          *dest_end|=(1<<offset);
        } else {
//printf("0");
        }
        if ((offset--)==0) {
          offset=7;
          *(--dest_end)=0;  //clean the space
        }
        if ((offset2--)==0) {
          offset2=7;
          ptr--;
        }
      }
//printf(" = %d",code[*pos].length);
    }
  }
//printf("ptr=%ld off=%d",dest_end,offset);
  free(code);
  return 1;
}
