// C Source File
// Created 27/07/2003; 11:54:55

#include "mkcomplib.h"

/*===============================================================================================
== Decompression of the tree for ziplib
=================================================================================================
== data : the beginning of the tree
== tree : the TREE stucture to fill
== nL : nLength : the number of different caracter : help to know the size of the tree
===============================================================================================*/

void decomp_tree(unsigned char * data, TREE * tree, unsigned char nL) {
  unsigned char * data_tree=data+nL;  //address the the begining of the compressed tree and the end of the caracter table
  char offset=0;
  unsigned char no=0;     //nb of the node
  unsigned char no_w=0;   //nb of the last node written
  unsigned char right_branch[256];
  unsigned char no_right_br=0;

left:

  if ((offset++)==7) {
    offset=0;
    data_tree++;
  }

  if ((*data_tree)&(1<<offset)) {  //1 => node
    tree[no].left_branch=++no_w;
    tree[no].node_left=1;
    right_branch[no_right_br++]=no;  //will look on the right after
    no=no_w;
    goto left;  //next
  }
  tree[no].left_branch=*(data++);  //no node on the left
  tree[no].node_left=0;

right:  //what is there on the right ?
  if ((offset++)==7) {
    offset=0;
    data_tree++;
  }

  if ((*data_tree)&(1<<offset)) {  //a node
    tree[no].right_branch=++no_w;   //link to the folowing node
    tree[no].node_right=1;
    no=no_w;
    goto left;  //look on the leftt
  }
  tree[no].right_branch=*(data++);  //no node
  tree[no].node_right=0;

  if ((no_right_br--)==0)  //no right branch anymore ?
    return;
  no=right_branch[no_right_br];  //next right branch

  goto right;
}


/*===============================================================================================
== Ziplib decompression
=================================================================================================
== data : pointer of the data to decompress
== length : length of the data to decompress
== str_tag : a string which contain the tag to add atthe end of the file. For exemple :
'\0','E','X','T','\O',OTH_TAG
== tag_length : length of the tag (the tag doesn't finish by '\0' ! impossible to use strlen !)
== error : pointer to return the error code
=================================================================================================
== return the handle of the decompressed datas
===============================================================================================*/
CompErr study_dzip(unsigned char * data, unsigned short length,
                   TREE * * tree, short * nL, unsigned short * file_len, short * byte_offset, short * bit_offset) {

  unsigned short nb_file;
  
  data++;
  if (*data!=0xFF && strcmp(&(data[length-3]),"ZIP")==0) //ce n'est pas un zip
    return COMP_ERR_NOT_A_COMP;

  nb_file=*(unsigned short *)(++data);
  
  if (nb_file!=1)
    return COMP_ERR_NOT_SUPPORTED_ZIP;
  
  *nL=*(unsigned short *)(data+=2);
  *byte_offset=*(unsigned short *)(data+=2);
  *bit_offset=*(unsigned short *)(data+=2);
  *file_len=*(unsigned short *)(data+=2);
    
  *tree=malloc((*nL)*sizeof(TREE));
  if (*tree==NULL)
    return COMP_ERR_MEM;
  memset(*tree,0,(*nL)*sizeof(TREE));

  decomp_tree(data+2,*tree,*nL);

  return COMP_NO_ERR;

}

/*===============================================================================================
== Ziplib decompression
=================================================================================================
== data : pointer of the data to decompress
== length : length of the data to decompress
== str_tag : a string which contain the tag to add atthe end of the file. For exemple :
'\0','E','X','T','\O',OTH_TAG
== tag_length : length of the tag (the tag doesn't finish by '\0' ! impossible to use strlen !)
== error : pointer to return the error code
=================================================================================================
== return the handle of the decompressed datas
===============================================================================================*/
CompErr mk_dzip(unsigned char * data, unsigned char * dest, const unsigned char * str_tag, unsigned char tag_length,
                TREE * tree, short nL, unsigned short file_len, short byte_offset, short bit_offset) {

  data=write_decomp(data+2+byte_offset,file_len,dest+2,tree,bit_offset,0);

  free(tree);

  *(unsigned short *)dest=file_len;
  
  for (nL=0;nL<tag_length;nL++) //copy of the personnalised tag for the decompression data -> var
    *(data++)=*(str_tag++);
      
  return COMP_NO_ERR;
}

