
#include "mkcomplib.h"

/*===============================================================================================
== Ziplib compresion
=================================================================================================
== data : data to compress
== length : length of data to compress
== type : filelib type of the data
== temp : boolean false if we create a TI-OS variable (add the "ZIP" tag)
                  true if it's temporary
== error : pointer to return the error code
=================================================================================================
== return the handle of the compressed datas
===============================================================================================*/
HANDLE zip_data_temp(unsigned char * data, unsigned short length, unsigned char type,
                     CompErr * error) {

  TREE * tree=NULL;
  short          nL;
  unsigned short comp_len;
  short          offset;

  HANDLE h;
  unsigned char * dest;
  
  *error=study_zip(data,length,&tree,&nL,&comp_len,&offset,TRUE);

  if (*error!=COMP_NO_ERR)
    return H_NULL;   
  
  h=HeapAlloc(comp_len+2);
  if (h==H_NULL) {
    free(tree);
    *error=COMP_ERR_MEM;
    return H_NULL;
  }
  dest=HLock(h);
  
  *error=mk_zip(data,length,dest,tree,nL,comp_len,offset,type,TRUE);
  
  if (*error!=COMP_NO_ERR) {
  	HeapFree(h);
  	return H_NULL;
  }
  
  HeapUnlock(h);
  return h;
}

